/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0
};

RE.editor = document.getElementById('editor');

document.addEventListener("selectionchange", function() {
 RE.backuprange();
 var selection = window.getSelection();
     if (selection.rangeCount > 0) {
      callback.selectionChange(RE.getCurrentNodeName())

     }

 });

RE.getCurrentNodeName = function() {
  var selection = window.getSelection();
       if (selection.rangeCount > 0) {
        return selection.getRangeAt(0).commonAncestorContainer.parentNode.nodeName
       }
      return "empty"
};

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURIComponent(RE.getHtml());
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
    var videoTag = document.getElementById("video-1");
    if(videoTag != null) {
     RE.changeVideoCover("video-1",function(){
                  callback.changeVideoCover();

               });

         RE.closeVideo("video-1",function() {
            callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
         })
    }
}

RE.getEncodeHtml = function() {
    window.callback.getEncodeHtml(encodeURIComponent(RE.getHtml()));
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.setBullets = function() {
    document.execCommand('InsertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('InsertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.scrollToSelection = function() {
$('body').scrollTop($(window.getSelection().anchorNode).offset().top);
}

RE.scrollToSelectionExt = function() {
  $('body').scrollTop(RE.getRelativeCaretYPosition());
}

RE.insertImage = function(url, alt, width, height) {
       var html = '<img style="display:block;width:' + width +  ';height:' + height + ';"  src="' + url + '" alt="' + alt + '" />';
    RE.insertHTML(html);
}

RE.insertExpression = function(url, alt, width, height) {
       var html = '<img style="display:inline-block;width:' + width +  ';height:' + height + ';"  src="' + url + '" alt="' + alt + '" />';
    RE.insertHTML(html);

}

RE.setAttribute = function(videoId) {
  var videoBlock = document.getElementById("video-1");
  videoBlock.setAttribute("data-id",videoId);
   callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
}


RE.insertVideo = function(url) {
  var html = '<div class="video-wrap" id="video-1">'
  + '<span class="background-cover js-cover"  style="background-image: url('  + url + ');"></span>'
  + '<img class="close js-close video" src="file:///android_res/drawable/editor_video_close.png">'
  + '<span class="upload-cover js-upload-cover">'
      + '修改封面'
  +  '</span>'
  + '<img class="play-btn js-play-btn video" src="file:///android_res/drawable/rich_editor_video_start.png">'

  + '<div class="progress js-progress">'
        + '<div class="progress-wrap" >'
              + '<div class="word-tip" >'
                 + '<span class="js-percent percent"></span>'
              + '开始上传'
              + '</div>'
              + '<div class="style-tip">'
              + '<span class="progress-percent js-progress-percent"></span>'
              + '</div>'
        + '</div>'
  + '</div>'
  + '<div class="upload-fail-to-again js-fail-to-again">'
      + '<span>上传失败，点击重新上传</span>'
      + '<img src="https://img.tapimg.com/market/images/1b815e847157736e90789e229c59f61e.png">'
  +'</div>'
  +'</div>'
  +'<div><br/></div>';
  RE.insertHTML(html);

  //某些机型直接在标签里添加contenteditable会丢失，故采用以下这种方法
  var videoTag = document.getElementById("video-1");
  if(videoTag != null) {
    videoTag.setAttribute("contenteditable",false)
  }
}

RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.deleteForward = function() {
    document.execCommand('delete', false, null);
}

function deleteElement(id) {
  var el = RE.editor;
  var range = document.createRange();
  range.selectNode(el);
  var sel = window.getSelection();
  sel.removeAllRanges();
  sel.addRange(range);
  document.execCommand("delete", false, null);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}


RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.getRelativeCaretYPosition = function() {
    var sel = window.getSelection();
    if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        range.collapse(false);
        var topPosition = -1;
//        if (!range.startContainer.offsetTop && range.startContainer.offsetTop != 0 ) {
            var span = document.createElement('span');// something happening here preventing selection of elements
            range.collapse(false);
            span.appendChild(document.createTextNode("  "))
            range.insertNode(span);
            topPosition = span.offsetTop
            span.parentNode.removeChild(span);
//        } else {
//            topPosition = range.startContainer.offsetTop + range.startContainer.offsetHeight ;
//        }
        return topPosition;
    }
    return -1
}

RE.getRange = function() {
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        return selection.getRangeAt(0);
    }
}

RE.getRangeClone = function() {
    var range = RE.getRange();
    if (typeof(range) == "undefined" || range == null) {
        return;
    }
    return range.cloneRange();
}

RE.selectNode = function(node) {
    if (typeof(node) == "undefined" || node == null) {
        return;
    }
    var range = RE.getRange();
    if (typeof(range) == "undefined" || range == null) {
            return;
    }
    range.selectNodeContents(node);
    RE.selectRange(range);
}

RE.selectRange = function(range) {
    if (typeof(range) == "undefined" || range == null) {
        return;
    }
    var sel = window.getSelection();
    sel.removeAllRanges();
    sel.addRange(range);
}

RE.saveRange = function() {
    RE.lastRange = RE.getRangeClone();
}

RE.enabledEditingItems = function(e) {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURIComponent(items.join(','));
}

RE.focus = function() {
//    var range = document.createRange();
//    range.selectNodeContents(RE.editor);
//    range.collapse(false);
//    var selection = window.getSelection();
//    selection.removeAllRanges();
//    selection.addRange(range);
    RE.editor.focus();
}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    execCommand('removeFormat', false, null);
}

/**
 *  从剪切板获取文本
 *  @params e 剪切板对象
 *  @return 是否已处理
 **/
RE.pasteNormalCallback = function(e) {
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);
    if (event.clipboardData || event.originalEvent) {
        var clipboardData = (event.clipboardData || event.originalEvent.clipboardData);
        if(typeof(clipboardData) != "undefined" && clipboardData != null){
            var data;
            if(clipboardData.types.indexOf('text/html') > -1) {//html
                data = clipboardData.getData('text/html');
            } else if(clipboardData.types.indexOf('text/plain') > -1) {//无文本格式
                data = clipboardData.getData('text/plain');
            }
            if (null != data) {
                if (null != range) {
                   range.deleteContents();
                }
                window.location.href = "re-check://" + encodeURIComponent(data);
                e.preventDefault(); // We are already handling the data from the clipboard, we do not want it inserted into the document
                return true;
            }
            return false;
        }
    }
}

/**
 *  使用透明布局插入方式
 *  代码参照 https://github.com/wbb/wysibb/blob/master/jquery.wysibb.js#L837
 *  @params e 剪切板对象
 *  @return 是否已处理
 **/
RE.pasteSpecialCallback =  function(e) {
    var originScrollTop = $('body').scrollTop();
    if (!RE.editor.pasteBlock) {
        RE.saveRange();
        // append translate div
        RE.pasteBlock = document.createElement("div");
        RE.pasteBlock.setAttribute("style", "opacity:0;");
        RE.pasteBlock.setAttribute("contenteditable", "true");
        RE.pasteBlock.innerHTML = "\uFEFF";
        RE.editor.appendChild(RE.pasteBlock);

        window.setTimeout(function() {
            var data = '<span>'+ RE.pasteBlock.innerHTML+'</span>';
            RE.editor.removeChild(RE.pasteBlock);
            RE.editor.focus();

            RE.selectRange(RE.lastRange);

            window.location.href = "re-check://" + encodeURIComponent(data);

            RE.pasteBlock = null;
            RE.lastRange = null;

            $('body').scrollTop(originScrollTop);
        }, 1);
        RE.selectNode(RE.pasteBlock);
        return true;
    }
    return false;
}

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems(e);
    }
});
RE.editor.addEventListener("click", RE.enabledEditingItems);
//RE.editor.addEventListener("paste", function(e) {
//    if (RE.pasteNormalCallback(e)) {
//        return;
//    }
//    if (RE.pasteSpecialCallback(e)) {
//        return;
//    }
//});


RE.videoProgress = function(id,percent) {
  var jsProgressPercent = document.querySelector('#' + id + ' .js-progress-percent');
  var jsPercent = document.querySelector('#' + id + ' .js-percent');
  var jsProgress = document.querySelector('#' + id + ' .js-progress');
  var jsPlayBtn = document.querySelector('#' + id + ' .js-play-btn');

  jsPercent.innerText = percent + '%';
  jsProgressPercent.style.width = percent + '%';
  if(percent == 100) {
     RE.closeVideo(id,function() {
          callback.cancelUploadVideo();
          callback.onReloadUrl(encodeURIComponent(RE.getHtml()))

        })
     RE.changeVideoCover(id,function(){
        callback.changeVideoCover();

     })
    jsProgress.parentNode.removeChild(jsProgress);	// 进度条隐藏
    jsPlayBtn.style.display = 'inline-block';
    callback.onReloadUrl(encodeURIComponent(RE.getHtml()))

  }
};

RE.closeVideo = function(id,callback) {
  var jsClose = document.querySelector('#' + id + ' .js-close');
  jsClose.style.display = 'inline-block'; 		// 删除按钮展示
  var wrap = document.querySelector('#' + id);
  jsClose.addEventListener('click', function () {
  						wrap.remove();
  						callback && callback();
  					});
}

RE.changeVideoCover = function(id,callback) {
  var jsUploadCover = document.querySelector('#' + id + ' .js-upload-cover');
    jsUploadCover.style.display = 'inline-block';  	// 修改封面展示
    jsUploadCover.addEventListener('click', callback);
}

RE.videoChangeCover = function(id,img) {
  var jsCover = document.querySelector('#' + id + ' .js-cover');
  if(jsCover != null) {
    jsCover.style.backgroundImage = 'url("' + img + '")'
  }
   callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
}

RE.videoUploadFailed = function(id) {
  var jsFailToAgain = document.querySelector('#' + id + ' .js-fail-to-again');
  var jsProgressWrap = document.querySelector('#' + id + ' .progress-wrap');
  var jsPercent = document.querySelector('#' + id + ' .js-percent');
  var jsProgressPercent = document.querySelector('#' + id + ' .js-progress-percent');
  jsFailToAgain.style.display = 'block';  	// 上传失败提示
  jsProgressWrap.style.display = 'none';
  jsPercent.innerText = '';
  jsProgressPercent.style.width = '0%';

  jsFailToAgain.addEventListener('click', function() {
     jsFailToAgain.style.display = 'none';
      jsProgressWrap.style.display = 'block';
      callback.onRetryUploadVideo();
  });

   callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
}

